'Potencjometr cyfrowy
'Copyright Robert Wogajew 2009
'10.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 48       'Deklaracja rozmiaru stosu sprztowego
$swstack = 32       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

Config Int0 = Falling       'Konfiguracja sposobu wyzwalania przerwania zewn. INT0 - opadajcym zboczem
On Int0 Check_encoder       'Deklaracja procedury obsugi przerwania INT0 - obsugujcego enkoder
Enable Int0       'Wczenie obsugi przerwania INT0

'Skonfigurowanie ukadu Timer0 do pracy w charakterze czasomierza dla obsugi multipleksowania wywietlacza LED
Config Timer0 = Timer , Prescale = 256       ' Uycie parametru Prescale spowoduje automatyczne uruchomienie licznika
On Timer0 Multiplex       'Deklaracja procedury obsugi przerwania OVF0 - od przepenienia licznika Timer0 - wywoywane co ok.8ms
Enable Timer0       'Wczenie obsugi przerwania OVF0 - inaczej Timer0

Enable Interrupts       'Wczenie globalnego zezwolenia na obsug przerwa systemowych

'Konfiguracja odbiornika RC5 wana z punktu widzenia wbudowanej procedury Getrc5
Config Rc5 = Pind.4 , Timer = 2
Set Portd.4       'Podcignicie wejcia sygnau z odbiornika RC5 do plusa zasilania

'Port obsugujcy katody wywietlacza LED ustawiamy jako wyjciowy z pocztkowym stanem wysokim na wszystkich
'wyprowadzeniach, ktry to stan jest w tym przypadku stanem nieaktywnym
Portb = &B11111111
Ddrb = &B11111111

'To samo dotyczy wyprowadze sterujcych dwoma anodami wywietlacza LED (dla kadej cyfry)
Set Portc.2
Set Portc.3
Set Ddrc.2       'DIG1 - anoda jednoci
Set Ddrc.3       'DIG10 - anoda dziesitek

'Podcigamy wejcia do plusa zasilania
Set Portc.0       'MEM - zworka konfigurujca zapamitywanie nastaw potencjometru - zaoona oznacza ZAPAMITUJ POOENIE
Set Portc.1       '33_63 - zworka konfigurujca liczb krokw regulacji - zaoona oznacza 63 KROKI
Set Portd.1       'Pierwsze z wyprowadze enkodera
Set Portd.2       'Drugie z wyprowadze enkodera  -wywoujce przerwanie INT0
Set Portd.3       'Przycisk enkodera

'Nieuywane porty jako wyjcia z aktywnym stanem "0"
Set Ddrd.0
Set Ddrd.5
Set Ddrd.6
Set Ddrd.7
Set Ddrb.7

'Aliasy portw - znaczenie opisano powyej - przy konfiguracji portw
Mem Alias Pinc.0
33_63 Alias Pinc.1
Ok Alias Pind.3
Dig1 Alias Portc.2
Dig10 Alias Portc.3


Dim Btemp1 As Byte , Btemp2 As Byte       'Tymczasowe zmienne pomocnicze

Dim Maximum As Byte       'Maksimum dla regulacji gonoci zalene od trybu 33_63 -> 0..33 lub 0..63
Dim Wiper As Byte       'Aktualna warto nastawy obu potencjometrw
Dim Old_wiper As Byte       'Stara warto nastawy obu potencjometrw - dla funkcji Mute/Demute
Dim Address As Byte , Command As Byte       'Zmienne procedury RC5

Dim Refresh As Bit       'Flaga dania wysania danych przy pomocy magistrali TWI
Dim Muted As Bit       'Wskanik uycia funkcji Mute

Dim Multi As Bit       'Wskanik dla procedury multipleksujcej wywietlacz LED - wybierajcy cyfr dziesitek/jednoci
Dim Int_temp As Byte       'Zmienna procedury multipleksujcej wywietlacz LED

Declare Sub Initialize
Declare Sub Send_data
Declare Sub Run_mute

'###################################################################################
Call Initialize

Do

  'Sprawdzamy czy nie wcinito Mute. Jeli tak to wywoujemy odpowiedni funkcj.
  If Ok = 0 Then Call Run_mute

  'Sprawdzamy czy nie nadzeszo polecenie regulacyjne z interfejsu podczerwieni RC5
  Getrc5(address , Command)

  If Address <> 255 Then
    Command = Command And &B01111111       'Maskowanie bitu Toggle - niewykorzystywany

    Select Case Command
      'Funkcja Mute
      Case 13:
                       Call Run_mute
                       Waitms 200
      'Funkcja Vol+
      Case 16:
                       If Wiper < Maximum Then
                          Incr Wiper
                          Set Refresh       'Ustawiamy flag dania wysania danych przy pomocy magistrali TWI
                       End If
      'Funkcja Vol-
      Case 17:
                       If Wiper > 0 Then
                          Decr Wiper
                          Set Refresh       'Ustawiamy flag dania wysania danych przy pomocy magistrali TWI
                        End If
    End Select
    Address = 255       'Czycimy adres
  End If


  'Sprawdzamy czy dano wysania danych po magistrali TWI
  'Flaga ustawiana jest w procedurze obsugi przerwania INT0blub w czci kodu odpowiedzialnej za obsug interfejsu RC5
  If Refresh = 1 Then

      Call Send_data       'Wysamy wycznie nastawy potencjometrw bez konfiguracji (gdy Refresh=1)

      'Zapisujemy nowe nastawy w EEPROMie Atmegi jeli tak stanowi zworka MEM
      If Mem = 0 Then Writeeeprom Wiper , 1

      Reset Refresh
  End If

Loop

'###################################################################################

'Tablica danych wyjciowych portu B dla kolejnych cyfr 0..9 oraz symbolu "-"
Digits:
Data 16 , 31 , 34 , 6 , 13 , 68 , 64 , 30 , 0 , 4 , 111

'###################################################################################

Sub Run_mute
  'Sprawdzamy czy wcinito Mute czy Demute czyli czy po raz pierwszy czy drugi itd...
  If Muted = 0 Then
      'Funkcja Mute
      Old_wiper = Wiper       'Zapamitujemy biec warto nastaw
      Wiper = 0       'Wyciszamy potencjometr
      Set Muted       'Aktualizujemy wskanik
  Else
      'Funkcja Demute
      Wiper = Old_wiper       'Przywracamy warto nastaw
      Reset Muted       'Aktualizujemy wskanik
  End If

  Set Refresh       'Ustawiamy flag dania przesania nowych nastaw do ukdu DS1881

  'I czekamy na puszczenie przycisku OK jeli byby nadal wcinity dla funkcji Mute/Demute
  Bitwait Ok , Set
End Sub

'###################################################################################
'Procedura wykorzystuje tryb Master interfejsu TWI. Nie implementowano obsugi bdw transmisji.
Sub Send_data
  'Wysyamy sygna Start
  Twcr = &B10100100       'Ustawiony TWINT, TWSTA, TWEN
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wykona Start i zgosi to ustawiajc flag TWINT

  'Wysyamy adres w trybie zapisu do DS1881
  Twdr = &B01010000       'Wpisujemy adres ukadu DS1881
  Twcr = &B10000100       'Ustawiony TWINT, skasowany TWSTA i ustawiony TWEN - i inicjujemy jego wysanie
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wyle Adres i zgosi to ustawiajc flag TWINT

  'Jeli Refresh=0 to wysyamy konfiguracj ukadu DS1881 -> tylko przy wczeniu urzdzenia
  If Refresh = 0 Then
     'Wysyamy konfiguracj dla DS1881
     ' Bit7 = 1 -> wskanik, e jest to konfiguracja
     ' Bit 6..3 = 0
     ' Bit2 = 1 -> pami ulotna  (bo dane zapisujemy w pamici Atmegi - jest trwalsza)
     ' Bit1 = 1 -> Zero crossing detection ON
     ' Bit0 = 33_63 (0-> 63 kroki, 1-> 33 kroki)
     Twdr = &B10000110
     Twdr.0 = 33_63       'Liczba krokw regulacji w zalenoci od ustawienia zworki 33_63
     Set Twcr.twint       'I inicjujemy wysanie danej
     Bitwait Twcr.twint , Set       'Czekamy, a TWI wyle dan i zgosi to ustawiajc flag TWINT
  End If

  'Wysyamy nastawy scalonego potencjometru Pot0  (bit7 i bit6 = 0)
  Twdr = Maximum - Wiper       'Odwrcenie wartoci
  Set Twcr.twint       'I inicjujemy wysanie
  Bitwait Twcr.twint , Set       'Czekamy, a interfejs TWI wyle dan i zgosi to ustawiajc flag TWINT

  'Wysyamy nastawy scalonego potencjometru Pot1  (bit7=0 i bit6 = 1)
  Twdr = Maximum - Wiper       'Odwrcenie wartoci
  Set Twdr.6       'znacznik, e dotyczy to Pot1
  Set Twcr.twint       'I inicjujemy wysanie
  Bitwait Twcr.twint , Set       'Czekamy, a  interfejs TWI wyle dan i zgosi to ustawiajc flag TWINT

  'Inicjujemy wysanie sygnau Stop
  Twcr = &B10010100       'Ustawiony TWINT, TWSTO i TWEN
  'I NIE czekamy na nic bo po Stop-ie nie jest ustawiana flaga TWINT
End Sub

'###################################################################################

Sub Initialize

 'Konfiguracja interfejsu TWI
 Twbr = 6       'Ustawiamy czstotliwo magistrali na 285kHz
 Twsr.twps1 = 0
 Twsr.twps0 = 0

 'Sprawdzamy stan zworek konfiguracyjnych i stosownie do nich uaktualniamy odpowiednie zmienne
 If 33_63 = 0 Then Maximum = 63 Else Maximum = 33       'Zworka liczby krokw regulacji

 If Mem = 0 Then       'Zworka konfigurujca zapamitywanie nastaw potencjometrw
    'Tryb z zapamitywaniem wartoci suwakw
    Readeeprom Wiper , 1
    'Jeli zapamitana warto jest bdna w stosunku do biecego trybu pracy to poddajemy j korekcie ustawiajc "suwak" na poowe zakresu
    If Wiper > Maximum Then Wiper = Maximum \ 2
 Else
  'Tryb BEZ zapamitywania wartoci suwakw ukad DS1881 po starcie ustawia automatycznie MUTE
   Wiper = 0       'Aby zmienna bya zgodna z tym, e ukad jest w funkcji MUTE
 End If

 Reset Refresh       'Czycimy falg by procedura Send_data wysaa oprcz nastaw potencjometrw take dane konfiguracyjne ukadu DS1881

 Call Send_data       'Wysanie danych i konfiguracji do ukadu DS1881

 Reset Muted       'Ustawienie pocztkowej wartoci zmiennej

End Sub

'###################################################################################

'Przerwanie INT0 - odpowiedzialne za obsug enkodera jako elementu regulacji lokalnej
'Przerwanie wywoywane jest opadajcym zboczem na porcie PIND.2 poczonym z jednym z wyprowadze enkodera
Check_encoder:

 If Pind.1 = 1 Then       'Sprawdzamy stan na drugim wyprowadzeniu enkodera w celu weryfikacji kierunku obrotu
    'Zwikszamy warto zmiennej Wiper jeli mieci si w zakresie zmian
    If Wiper < Maximum Then
      Incr Wiper
      Set Refresh       'Ustawiamy flag dania wysania danych przy uyciu interfejsu TWI (dla ptli gwnej)
    End If
 Else
    'Zmniejszamy warto zmiennej Wiper jeli mieci si w zakresie zmian
    If Wiper > 0 Then
      Decr Wiper
      Set Refresh       'Ustawiamy flag dania wysania danych przy uyciu interfejsu TWI (dla ptli gwnej)
    End If
 End If

Return

'###################################################################################

'Przerwanie OVF0 odpowiedzialne za multipleksowanie wywietlacza LED i wywietlanie na nim wartoci regulacji
'Wywoywane bdzie co ok.8ms co daje czstotliwo odwierzania ok.61Hz dla kadej cyfry
Multiplex:

 'Sprawdzamy stan flagi Multi, ktra zmienia si z kadym wywoaniem przerwania by wywietli kolejn cyfr
 If Multi = 0 Then
    Int_temp = 10       'Domylnie wygaszony czyli wywietla "-"
    If Wiper <> 0 Then Int_temp = Wiper \ 10       'Cyfra dziesitek
    Set Dig1       'Wyczamy anod cyfry jednoci
    Portb = Lookup(int_temp , Digits)       'Wysyamy na port katod odpowiedni warto korzystajc z tablicy Digits
    Reset Dig10       'Wczamy anod cyfry dziesitek
 Else
    Int_temp = 10       'Domylnie wygaszony czyli wywietla "-"
    If Wiper <> 0 Then Int_temp = Wiper Mod 10       'Cyfra jednoci
    Set Dig10       'Wyczamy anod cyfry dziesitek
    Portb = Lookup(int_temp , Digits)       'Wysyamy na port katod odpowiedni warto korzystajc z tablicy Digits
    Reset Dig1       'Wczamy anod cyfryjednoci
 End If

 Toggle Multi       'Zmiana stanu flagi Multi

Return