'Sterownik RGB z interfejsem RC5
'Copyright Robert Wogajew 2009
'08.11.2009
$regfile = "m8def.dat"       'Deklaracja typu uywanego mikrokontrolera
$crystal = 8000000       'Deklaracja czstotliwoci zegara taktujcego procesor- musi byc zgodna z Fuse-bits
$hwstack = 32       'Deklaracja rozmiaru stosu sprztowego
$swstack = 24       'Deklaracja rozmiaru stosu programowego
$framesize = 40       'Deklaracja rozmiaru obszaru tzw.ramki

'Konfiguracja ukadw Timer1 i Timer2 jako 8-bitowych generatorw PWM - do sterowania prac moduw LED
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Prescale = 64
Config Timer2 = Pwm , Pwm = On , Compare Pwm = Clear Up , Prescale = 64

'Konfiguracja odbiornika RC5
Config Rc5 = Pind.2
'Wczenie globalnego zezwolenia na obsug przerwa systemowych. Wymagane z uwagi na procedur obsugi
'przerwania OVF0, z ktrej to korzysta wbudowana procedura Getrc5 realizujca odbieranie komend standardu RC5
Enable Interrupts

'Konfiguracje portw I/O
Set Portd.2       'Podcignicie portu RC5 pod zasilanie - domylnie jest wejciem
Set Portd.6       'Niezbdne dla domylnego wyczenia diody LED2
Set Portd.7       'Niezbdne dla domylnego wyczenia diody LED1
Ddrd = &B11111011       'Bit.2 (INT0) jako wejcie sygnau RC5, reszta jako wyjcia
Ddrb = &B11111111       'Wszystkie jako wyjcia w tym wykorzystane jedynie OC1A (pin 1)-> R, OC1B (pin 2)-> G i OC2 (pin 3)-> B
Ddrc = &B11111111       'Wszystkie jako wyjcia

Dim Work_mode As Byte       'Biecy tryb pracy sterownika
Dim Rgb As Word       'Zmienna skadowych kolorw RGB
Dim Address As Byte , Command As Byte       'Zmienne dla procedury Getrc5
Dim Btemp As Byte       'Zmienna tymczasowa
Dim Refresh As Bit       'Flaga dania zmiany nastaw generatorw PWM

'Deklaracja procedury, ktra zmienn Rgb (typu Word  ale o zakresie 0..1535) transponuje na skadowe R, G i B - te skadowe
'aduje bezporednio do rejestrw porwnania poszczeglnych Timerw by uzyska podan barw (wedug symulowanej palety)
Declare Sub Transpose_rgb
'Procedura obsugujca dekodowanie rozkazw interfejsu podczerwieni RC5
Declare Sub Decode_rc5_data

'Na pocztku odczytujemy zapisane parametry pracy urzdzenia korzystajc z wbudowanegj pamici EEPROM
'Komrka #1 i #2 - to zapamitana warto zmiennej RGB (2 bajty, gdy zmienna jest typu Word)
Readeeprom Btemp , 1       'Starszy bajt
Rgb = Btemp
Shift Rgb , Left , 8
Readeeprom Btemp , 2       'Modszy bajt
Rgb = Rgb Or Btemp
If Rgb > 1535 Then Rgb = 0       'Zabezpieczenie przed bdn wartoci

'Komrka #3 - to zapamitany tryb pracy sterownika
Readeeprom Work_mode , 3
If Work_mode > 2 Then Work_mode = 0       'Zabezpieczenie przed bdn wartoci
'Sygnalizacja trybu pracy urzdzenia - wykonywana za pomoc diod LED
Portd.6 = Not Work_mode.1
Portd.7 = Not Work_mode.0
'Pierwsze ustawienie flagi spowoduje zastosowanie odczytanych parametrw
Set Refresh

'###################################################################################
'###################################################################################
Do
 'Obsugujemy interfejs RC5
 Getrc5(address , Command)

 'Sprawdzamy, czy nadszed jaki rozkaz sterujcy
 If Address <> 255 Then
    'Jeli tak, to maskujemy bit Toggle, gdy nie jest obsugiwany przrz nasz sterownik
    Command = Command And &B01111111
    'Dekodujemy odebrany rozkaz w zakresie wartoci obsugiwanych przez niniejszy sterownik. Jeli rozkaz sterujcy
    'dotyczy niniejszego sterownika to nastpi aktualizacja odpowiednich zmiennych sterujcych i ustawienie flagi Refresh
    Call Decode_rc5_data
 End If

 'W zalenoci od biecego trybu pracy urzdzenia dokonujemy odpowiednich procedur regulacyjnych
 Select Case Work_mode
   Case 0:
              'danie wyczenia diod LED bez zmiany biecych wartoci zmiennych sterujcych
              If Refresh = 1 Then
                 Pwm1a = 0
                 Pwm1b = 0
                 Ocr2 = 0
                 Reset Refresh
              End If
   Case 1:
              'Tryb rcznej regulacji koloru
              If Refresh = 1 Then
                 Call Transpose_rgb
                 Reset Refresh
              End If
   Case 2:
              'Tryb automatycznej, pynnej regulacji koloru
              Rgb = Rgb + 8       ' W ten sposb otrzymujemy 192 automatyczne kroki regulacyjne
              If Rgb > 1535 Then Rgb = 0
              Call Transpose_rgb
 End Select

Loop

'###################################################################################
'###################################################################################

Sub Decode_rc5_data

  Select Case Command
     Case 55:
                        'Przycisk TXT czerwony -> zmiana trybu pracy Work_mode
                         Incr Work_mode
                         If Work_mode > 2 Then Work_mode = 0
                         If Work_mode <> 2 Then Set Refresh
                         'Aktualizacja trybu pracy urzdzenia - wykonywana za pomoc diod LED
                         Portd.6 = Not Work_mode.1
                         Portd.7 = Not Work_mode.0
                         Waitms 100
     Case 54:
                         'Przycisk TXT zielony  ->  Zmiana koloru moduu LED w kierunku pocztku zastosowanej palety kolorw
                         If Work_mode = 1 Then
                            If Rgb > 15 Then Rgb = Rgb -16 Else Rgb = 1535
                            Set Refresh
                         End If
     Case 50:
                         'Przycisk TXT ty ->  Zmiana koloru moduu LED w kierunku koca zastosowanej palety kolorw
                         If Work_mode = 1 Then
                            Rgb = Rgb + 16
                            If Rgb > 1535 Then Rgb = 0
                            Set Refresh
                         End If
     Case 52:
                         'Przycisk TXT niebieski -> zapamitanie biecych parametrw pracy sterownika
                         Btemp = High(rgb)
                         Writeeeprom Btemp , 1
                         Btemp = Low(rgb)
                         Writeeeprom Btemp , 2
                         Writeeeprom Work_mode , 3
  End Select

End Sub

'###################################################################################
'Procedura przewiduje 1536 krokw regulacyjnych cho sterownik ogranicza jej rozdzielczo do 96 lub 192.
Sub Transpose_rgb
Local X As Byte       'Zmienna lokalna uywana wycznie przez t procedur

 X = Low(rgb)

 Select Case Rgb
  Case 0 To 255:
                     Pwm1a = 255
                     Pwm1b = 0
                     Ocr2 = X
  Case 256 To 511:
                     Pwm1a = 255 - X
                     Pwm1b = 0
                     Ocr2 = 255
  Case 512 To 767:
                     Pwm1a = 0
                     Pwm1b = X
                     Ocr2 = 255
  Case 768 To 1023:
                     Pwm1a = 0
                     Pwm1b = 255
                     Ocr2 = 255 - X
  Case 1024 To 1279:
                     Pwm1a = X
                     Pwm1b = 255
                     Ocr2 = 0
  Case 1280 To 1535:
                     Pwm1a = 255
                     Pwm1b = 255 - X
                     Ocr2 = 0
 End Select

End Sub

'###################################################################################